diff -urN ../sys/net/if_var.h ./net/if_var.h
--- ../sys/net/if_var.h	Wed Jul 25 04:10:18 2001
+++ ./net/if_var.h	Tue Oct  2 22:06:21 2001
@@ -74,6 +74,9 @@
 #endif
 
 #include <sys/queue.h>		/* get TAILQ macros */
+#if 1 /* ALTQ */
+#include <altq/if_altq.h>
+#endif
 
 TAILQ_HEAD(ifnethead, ifnet);	/* we use TAILQs so that the order of */
 TAILQ_HEAD(ifaddrhead, ifaddr);	/* instantiation is preserved in the list */
@@ -137,7 +140,11 @@
 		__P((void *));
 	int	(*if_resolvemulti)	/* validate/resolve multicast */
 		__P((struct ifnet *, struct sockaddr **, struct sockaddr *));
+#if 1 /* ALTQ */
+	struct	ifaltq if_snd;		/* output queue (includes altq) */
+#else
 	struct	ifqueue if_snd;		/* output queue */
+#endif
 	struct	ifqueue *if_poll_slowq;	/* input queue for slow devices */
 	struct	ifprefixhead if_prefixhead; /* list of prefixes per if */
 };
@@ -210,6 +217,17 @@
 		(ifq)->ifq_len--; \
 	} \
 }
+#define	IF_POLL(ifq, m)		((m) = (ifq)->ifq_head)
+#define	IF_PURGE(ifq)							\
+while (1) {								\
+	struct mbuf *m0;						\
+	IF_DEQUEUE((ifq), m0);						\
+	if (m0 == NULL)							\
+		break;							\
+	else								\
+		m_freem(m0);						\
+}
+#define	IF_IS_EMPTY(ifq)	((ifq)->ifq_len == 0)
 
 #ifdef _KERNEL
 #define	IF_ENQ_DROP(ifq, m)	if_enq_drop(ifq, m)
@@ -248,6 +266,110 @@
 
 #endif /* _KERNEL */
 
+#ifdef _KERNEL
+#ifdef ALTQ
+
+#define	IFQ_ENQUEUE(ifq, m, pattr, err)					\
+do {									\
+	if (ALTQ_IS_ENABLED((ifq)))					\
+		ALTQ_ENQUEUE((ifq), (m), (pattr), (err));		\
+	else {								\
+		if (IF_QFULL((ifq))) {					\
+			m_freem((m));					\
+			(err) = ENOBUFS;				\
+		} else {						\
+			IF_ENQUEUE((ifq), (m));				\
+			(err) = 0;					\
+		}							\
+	}								\
+	if ((err))							\
+		(ifq)->ifq_drops++;					\
+} while (0)
+
+#define	IFQ_DEQUEUE(ifq, m)						\
+do {									\
+	if (TBR_IS_ENABLED((ifq)))					\
+		(m) = tbr_dequeue((ifq), ALTDQ_REMOVE);			\
+	else if (ALTQ_IS_ENABLED((ifq)))				\
+		ALTQ_DEQUEUE((ifq), (m));				\
+	else								\
+		IF_DEQUEUE((ifq), (m));					\
+} while (0)
+
+#define	IFQ_POLL(ifq, m)						\
+do {									\
+	if (TBR_IS_ENABLED((ifq)))					\
+		(m) = tbr_dequeue((ifq), ALTDQ_POLL);			\
+	else if (ALTQ_IS_ENABLED((ifq)))				\
+		ALTQ_POLL((ifq), (m));					\
+	else								\
+		IF_POLL((ifq), (m));					\
+} while (0)
+
+#define	IFQ_PURGE(ifq)							\
+do {									\
+	if (ALTQ_IS_ENABLED((ifq)))					\
+		ALTQ_PURGE((ifq));					\
+	else								\
+		IF_PURGE((ifq));					\
+} while (0)
+
+#define	IFQ_SET_READY(ifq)						\
+	do { ((ifq)->altq_flags |= ALTQF_READY); } while (0)
+
+#define	IFQ_CLASSIFY(ifq, m, af, pa)					\
+do {									\
+	if (ALTQ_IS_ENABLED((ifq))) {					\
+		if (ALTQ_NEEDS_CLASSIFY((ifq)))				\
+			(pa)->pattr_class = (*(ifq)->altq_classify)	\
+				((ifq)->altq_clfier, (m), (af));	\
+		(pa)->pattr_af = (af);					\
+		(pa)->pattr_hdr = mtod((m), caddr_t);			\
+	}								\
+} while (0)
+
+#else /* !ALTQ */
+
+#define	IFQ_ENQUEUE(ifq, m, err)					\
+do {									\
+	if (IF_QFULL((ifq))) {						\
+		m_freem((m));						\
+		(err) = ENOBUFS;					\
+	} else {							\
+		IF_ENQUEUE((ifq), (m));					\
+		(err) = 0;						\
+	}								\
+	if ((err))							\
+		(ifq)->ifq_drops++;					\
+} while (0)
+
+#define	IFQ_DEQUEUE(ifq, m)	IF_DEQUEUE((ifq), (m))
+
+#define	IFQ_POLL(ifq, m)	IF_POLL((ifq), (m))
+
+#define	IFQ_PURGE(ifq)							\
+while (1) {								\
+	struct mbuf *m0;						\
+	IF_DEQUEUE((ifq), m0);						\
+	if (m0 == NULL)							\
+		break;							\
+	else								\
+		m_freem(m0);						\
+}
+
+#define	IFQ_SET_READY(ifq)		((void)0)
+#define	IFQ_CLASSIFY(ifq, m, af, pa)	((void)0)
+
+#endif /* !ALTQ */
+
+#define	IFQ_IS_EMPTY(ifq)		((ifq)->ifq_len == 0)
+#define	IFQ_INC_LEN(ifq)		((ifq)->ifq_len++)
+#define	IFQ_DEC_LEN(ifq)		(--(ifq)->ifq_len)
+#define	IFQ_INC_DROPS(ifq)		((ifq)->ifq_drops++)
+#define	IFQ_SET_MAXLEN(ifq, len)	((ifq)->ifq_maxlen = (len))
+
+#endif /* _KERNEL */
+
 /*
  * The ifaddr structure contains information about one address
  * of an interface.  They are maintained by the different address families,
@@ -332,6 +454,10 @@
 	   struct mbuf *, struct sockaddr *, struct rtentry *));
 int	ether_output_frame __P((struct ifnet *, struct mbuf *));
 int	ether_ioctl __P((struct ifnet *, int, caddr_t));
+#ifdef ALTQ
+int	altq_etherclassify __P((struct ifaltq *, struct mbuf *,
+				struct altq_pktattr *));
+#endif
 
 int	if_addmulti __P((struct ifnet *, struct sockaddr *,
 			 struct ifmultiaddr **));
diff -urN ../sys/netinet/if_atm.c ./netinet/if_atm.c
--- ../sys/netinet/if_atm.c	Wed Dec  8 02:39:06 1999
+++ ./netinet/if_atm.c	Tue Oct  2 22:06:21 2001
@@ -95,7 +95,9 @@
 	switch (req) {
 
 	case RTM_RESOLVE: /* resolve: only happens when cloning */
+#ifdef DIAGNOSTIC
 		printf("atm_rtrequest: RTM_RESOLVE request detected?\n");
+#endif
 		break;
 
 	case RTM_ADD:
@@ -116,12 +118,16 @@
 		}
 
 		if ((rt->rt_flags & RTF_CLONING) != 0) {
+#ifdef DIAGNOSTIC
 			printf("atm_rtrequest: cloning route detected?\n");
+#endif
 			break;
 		}
 		if (gate->sa_family != AF_LINK ||
 		    gate->sa_len < sizeof(null_sdl)) {
+#ifdef DIAGNOSTIC
 			log(LOG_DEBUG, "atm_rtrequest: bad gateway value");
+#endif
 			break;
 		}
 
diff -urN ../sys/netinet/ip_input.c ./netinet/ip_input.c
--- ../sys/netinet/ip_input.c	Thu Aug 30 06:41:37 2001
+++ ./netinet/ip_input.c	Tue Oct  2 22:06:21 2001
@@ -369,6 +369,11 @@
 		goto bad;
 	}
 
+#ifdef ALTQ
+	if (altq_input != NULL && (*altq_input)(m, AF_INET) == 0)
+		/* packet is dropped by traffic conditioner */
+		return;
+#endif
 	/*
 	 * Convert fields to host representation.
 	 */
@@ -1791,9 +1796,19 @@
 		break;
 
 	case ENOBUFS:
+#ifdef ALTQ
+		/*
+		 * don't generate ICMP_SOURCEQUENCH
+		 * (RFC1812 Requirements for IP Version 4 Routers)
+		 */
+		if (mcopy)
+			m_freem(mcopy);
+		return;
+#else
 		type = ICMP_SOURCEQUENCH;
 		code = 0;
 		break;
+#endif
 
 	case EACCES:			/* ipfw denied packet */
 		m_freem(mcopy);
diff -urN ../sys/netinet/ip_mroute.c ./netinet/ip_mroute.c
--- ../sys/netinet/ip_mroute.c	Thu Jul 19 15:37:26 2001
+++ ./netinet/ip_mroute.c	Tue Oct  2 22:06:21 2001
@@ -30,6 +30,7 @@
 #include <net/route.h>
 #include <netinet/in.h>
 #include <netinet/in_systm.h>
+#include <netinet/in_pcb.h>
 #include <netinet/ip.h>
 #include <netinet/ip_var.h>
 #include <netinet/in_var.h>
@@ -2136,6 +2137,12 @@
     static struct sockaddr_in rsvp_src = { sizeof rsvp_src, AF_INET };
     register int s;
     struct ifnet *ifp;
+#ifdef ALTQ
+    /* support IP_RECVIF used by rsvpd rel4.2a1 */
+    struct inpcb *inp;
+    struct socket *so;
+    struct mbuf *opts;
+#endif
 
     if (rsvpdebug)
 	printf("rsvp_input: rsvp_on %d\n",rsvp_on);
@@ -2165,7 +2172,11 @@
 	if (viftable[vifi].v_ifp == ifp)
 	    break;
 
+#ifdef ALTQ
+    if (vifi == numvifs || (so = viftable[vifi].v_rsvpd) == NULL) {
+#else
     if (vifi == numvifs || viftable[vifi].v_rsvpd == NULL) {
+#endif
 	/*
 	 * If the old-style non-vif-associated socket is set,
 	 * then use it.  Otherwise, drop packet since there
@@ -2191,6 +2202,26 @@
 	printf("rsvp_input: m->m_len = %d, sbspace() = %ld\n",
 	       m->m_len,sbspace(&(viftable[vifi].v_rsvpd->so_rcv)));
 
+#ifdef ALTQ
+    opts = NULL;
+    inp = (struct inpcb *)so->so_pcb;
+    if (inp->inp_flags & INP_CONTROLOPTS ||
+	inp->inp_socket->so_options & SO_TIMESTAMP)
+	ip_savecontrol(inp, &opts, ip, m);
+    if (sbappendaddr(&so->so_rcv,
+		     (struct sockaddr *)&rsvp_src,m, opts) == 0) {
+	m_freem(m);
+	if (opts)
+	    m_freem(opts);
+	if (rsvpdebug)
+	    printf("rsvp_input: Failed to append to socket\n");
+    }
+    else {
+	sorwakeup(so);
+	if (rsvpdebug)
+	    printf("rsvp_input: send packet up\n");
+    }
+#else /* !ALTQ */
     if (socket_send(viftable[vifi].v_rsvpd, m, &rsvp_src) < 0) {
 	if (rsvpdebug)
 	    printf("rsvp_input: Failed to append to socket\n");
@@ -2198,6 +2229,7 @@
 	if (rsvpdebug)
 	    printf("rsvp_input: send packet up\n");
     }
+#endif /* !ALTQ */
 
     splx(s);
 }
diff -urN ../sys/netinet/ip_output.c ./netinet/ip_output.c
--- ../sys/netinet/ip_output.c	Thu Jul 19 15:37:26 2001
+++ ./netinet/ip_output.c	Tue Oct  2 22:06:21 2001
@@ -396,6 +396,12 @@
 #endif /* IPFIREWALL_FORWARD */
 	}
 #endif /* notdef */
+#ifdef ALTQ
+	/*
+	 * disable packet drop hack.
+	 * packetdrop should be done by queueing.
+	 */
+#else /* !ALTQ */
 	/*
 	 * Verify that we have any chance at all of being able to queue
 	 *      the packet or packet fragments
@@ -405,6 +411,7 @@
 			error = ENOBUFS;
 			goto bad;
 	}
+#endif /* !ALTQ */
 
 	/*
 	 * Look for broadcast address and
diff -urN ../sys/netinet6/ip6_input.c ./netinet6/ip6_input.c
--- ../sys/netinet6/ip6_input.c	Wed Jul 25 04:10:18 2001
+++ ./netinet6/ip6_input.c	Tue Oct  2 22:06:21 2001
@@ -350,6 +350,12 @@
 
 	ip6stat.ip6s_nxthist[ip6->ip6_nxt]++;
 
+#ifdef ALTQ
+	if (altq_input != NULL && (*altq_input)(m, AF_INET6) == 0) {
+		/* packet is dropped by traffic conditioner */
+		return;
+	}
+#endif
 	/*
 	 * Check with the firewall...
 	 */
diff -urN ../sys/pci/if_dc.c ./pci/if_dc.c
--- ../sys/pci/if_dc.c	Fri Jul 20 11:01:26 2001
+++ ./pci/if_dc.c	Tue Oct  2 22:06:21 2001
@@ -1912,7 +1912,8 @@
 	ifp->if_watchdog = dc_watchdog;
 	ifp->if_init = dc_init;
 	ifp->if_baudrate = 10000000;
-	ifp->if_snd.ifq_maxlen = DC_TX_LIST_CNT - 1;
+	IFQ_SET_MAXLEN(&ifp->if_snd, DC_TX_LIST_CNT - 1);
+	IFQ_SET_READY(&ifp->if_snd);
 
 	/*
 	 * Do MII setup. If this is a 21143, check for a PHY on the
@@ -2540,7 +2541,7 @@
 		if (mii->mii_media_status & IFM_ACTIVE &&
 		    IFM_SUBTYPE(mii->mii_media_active) != IFM_NONE) {
 			sc->dc_link++;
-			if (ifp->if_snd.ifq_head != NULL)
+			if (!IFQ_IS_EMPTY(&ifp->if_snd))
 				dc_start(ifp);
 		}
 	}
@@ -2678,7 +2679,7 @@
 	/* Re-enable interrupts. */
 	CSR_WRITE_4(sc, DC_IMR, DC_INTRS);
 
-	if (ifp->if_snd.ifq_head != NULL)
+	if (!IFQ_IS_EMPTY(&ifp->if_snd))
 		dc_start(ifp);
 
 	return;
@@ -2742,6 +2743,11 @@
 		sc->dc_ldata->dc_tx_list[cur].dc_ctl |= DC_TXCTL_FINT;
 	if (sc->dc_flags & DC_TX_USE_TX_INTR && sc->dc_cdata.dc_tx_cnt > 64)
 		sc->dc_ldata->dc_tx_list[cur].dc_ctl |= DC_TXCTL_FINT;
+#ifdef ALTQ
+	else if ((sc->dc_flags & DC_TX_USE_TX_INTR) &&
+		 TBR_IS_ENABLED(&sc->arpcom.ac_if.if_snd))
+		sc->dc_ldata->dc_tx_list[cur].dc_ctl |= DC_TXCTL_FINT;
+#endif
 	sc->dc_ldata->dc_tx_list[*txidx].dc_status = DC_TXSTAT_OWN;
 	*txidx = frag;
 
@@ -2806,24 +2812,34 @@
 	idx = sc->dc_cdata.dc_tx_prod;
 
 	while(sc->dc_cdata.dc_tx_chain[idx] == NULL) {
-		IF_DEQUEUE(&ifp->if_snd, m_head);
+		IFQ_POLL(&ifp->if_snd, m_head);
 		if (m_head == NULL)
 			break;
 
 		if (sc->dc_flags & DC_TX_COALESCE) {
+#ifdef ALTQ
+			/* note: dc_coal breaks the poll-and-dequeue rule.
+			 * if dc_coal fails, we lose the packet.
+			 */
+#endif
+			IFQ_DEQUEUE(&ifp->if_snd, m_head);
 			if (dc_coal(sc, &m_head)) {
-				IF_PREPEND(&ifp->if_snd, m_head);
 				ifp->if_flags |= IFF_OACTIVE;
 				break;
 			}
 		}
 
 		if (dc_encap(sc, m_head, &idx)) {
-			IF_PREPEND(&ifp->if_snd, m_head);
 			ifp->if_flags |= IFF_OACTIVE;
 			break;
 		}
 
+		/* now we are committed to transmit the packet */
+		if (sc->dc_flags & DC_TX_COALESCE) {
+			/* if mbuf is coalesced, it is already dequeued */
+		} else
+			IFQ_DEQUEUE(&ifp->if_snd, m_head);
+
 		/*
 		 * If there's a BPF listener, bounce a copy of this frame
 		 * to him.
@@ -2836,6 +2852,8 @@
 			break;
 		}
 	}
+	if (idx == sc->dc_cdata.dc_tx_prod)
+		return;
 
 	/* Transmit */
 	sc->dc_cdata.dc_tx_prod = idx;
@@ -3142,7 +3160,7 @@
 	dc_reset(sc);
 	dc_init(sc);
 
-	if (ifp->if_snd.ifq_head != NULL)
+	if (!IFQ_IS_EMPTY(&ifp->if_snd))
 		dc_start(ifp);
 
 	return;
diff -urN ../sys/pci/if_de.c ./pci/if_de.c
--- ../sys/pci/if_de.c	Sat Aug  5 08:25:09 2000
+++ ./pci/if_de.c	Tue Oct  2 22:06:21 2001
@@ -4135,6 +4135,11 @@
 #else
     struct mbuf *m0;
 #endif
+#if 1 /* ALTQ */
+    struct ifnet *ifp = &sc->tulip_if;
+    struct mbuf *ombuf = m;
+    int compressed = 0;
+#endif
 
 #if defined(TULIP_DEBUG)
     if ((sc->tulip_cmdmode & TULIP_CMD_TXRUN) == 0) {
@@ -4285,6 +4290,26 @@
 		 * entries that we can use for one packet, so we have
 		 * recopy it into one mbuf and then try again.
 		 */
+#if 1 /* ALTQ */
+		struct mbuf *tmp;
+		/*
+		 * tulip_mbuf_compress() frees the original mbuf.
+		 * thus, we have to remove the mbuf from the queue
+		 * before calling it.
+		 * we don't have to worry about space shortage
+		 * after compressing the mbuf since the compressed
+		 * mbuf will take only two segs.
+		 */
+		if (compressed) {
+		    /* should not happen */
+		    printf("tulip_txput: compress called twice!\n");
+		    goto finish;
+		}
+		IFQ_DEQUEUE(&ifp->if_snd, tmp);
+		if (tmp != ombuf)
+		    panic("tulip_txput: different mbuf dequeued!");
+		compressed = 1;
+#endif
 		m = tulip_mbuf_compress(m);
 		if (m == NULL)
 		    goto finish;
@@ -4346,6 +4371,16 @@
      * The descriptors have been filled in.  Now get ready
      * to transmit.
      */
+#if 1 /* ALTQ */
+    if (!compressed && (sc->tulip_flags & TULIP_TXPROBE_ACTIVE) == 0) {
+	/* remove the mbuf from the queue */
+	struct mbuf *tmp;
+	IFQ_DEQUEUE(&ifp->if_snd, tmp);
+	if (tmp != ombuf)
+	    panic("tulip_txput: different mbuf dequeued!");
+    }
+#endif
+
     IF_ENQUEUE(&sc->tulip_txq, m);
     m = NULL;
 
@@ -4693,6 +4728,14 @@
     return error;
 }
 
+#if 1 /* ALTQ */
+/*
+ * the original dequeueing policy is dequeue-and-prepend if something
+ * goes wrong.  when altq is used, it is changed to peek-and-dequeue.
+ * the modification becomes a bit complicated since tulip_txput() might
+ * copy and modify the mbuf passed.
+ */
+#endif
 /*
  * These routines gets called at device spl (from ether_output).  This might
  * pose a problem for TULIP_USE_SOFTINTR if ether_output is called at
@@ -4711,15 +4754,23 @@
 	if ((sc->tulip_flags & (TULIP_WANTSETUP|TULIP_TXPROBE_ACTIVE)) == TULIP_WANTSETUP)
 	    tulip_txput_setup(sc);
 
-	while (sc->tulip_if.if_snd.ifq_head != NULL) {
-	    struct mbuf *m;
-	    IF_DEQUEUE(&sc->tulip_if.if_snd, m);
-	    if ((m = tulip_txput(sc, m)) != NULL) {
-		IF_PREPEND(&sc->tulip_if.if_snd, m);
+	while (!IFQ_IS_EMPTY(&sc->tulip_if.if_snd)) {
+	    struct mbuf *m, *m0;
+	    IFQ_POLL(&sc->tulip_if.if_snd, m);
+	    if (m == NULL)
+		break;
+	    if ((m0 = tulip_txput(sc, m)) != NULL) {
+		if (m0 != m)
+		    /* should not happen */
+		    printf("tulip_if_start: txput failed!\n");
 		break;
 	    }
 	}
-	if (sc->tulip_if.if_snd.ifq_head == NULL)
+#ifdef ALTQ
+	if (0) /* don't switch to the one packet mode */
+#else
+	if (IFQ_IS_EMPTY(&sc->tulip_if.if_snd))
+#endif
 	    sc->tulip_if.if_start = tulip_ifstart_one;
     }
 
@@ -4734,11 +4785,13 @@
     tulip_softc_t * const sc = (tulip_softc_t *)ifp->if_softc;
 
     if ((sc->tulip_if.if_flags & IFF_RUNNING)
-	    && sc->tulip_if.if_snd.ifq_head != NULL) {
-	struct mbuf *m;
-	IF_DEQUEUE(&sc->tulip_if.if_snd, m);
-	if ((m = tulip_txput(sc, m)) != NULL)
-	    IF_PREPEND(&sc->tulip_if.if_snd, m);
+	    && !IFQ_IS_EMPTY(&sc->tulip_if.if_snd)) {
+	struct mbuf *m, *m0;
+	IFQ_POLL(&sc->tulip_if.if_snd, m);
+	if (m != NULL && (m0 = tulip_txput(sc, m)) != NULL)
+	    if (m0 != m)
+		/* should not happen */
+		printf("tulip_if_start_one: txput failed!\n");
     }
     TULIP_PERFEND(ifstart_one);
 }
@@ -4844,7 +4897,8 @@
     ifp->if_watchdog = tulip_ifwatchdog;
     ifp->if_timer = 1;
     ifp->if_output = ether_output;
-  
+    IFQ_SET_READY(&ifp->if_snd);
+
     printf("%s%d: %s%s pass %d.%d%s\n",
 	   sc->tulip_name, sc->tulip_unit,
 	   sc->tulip_boardid,
@@ -4874,8 +4928,8 @@
 
     tulip_reset(sc);
 
+    IFQ_SET_MAXLEN(&ifp->if_snd, ifqmaxlen);
     ether_ifattach(&(sc)->tulip_if, ETHER_BPF_SUPPORTED);
-    ifp->if_snd.ifq_maxlen = ifqmaxlen;
 }
 
 #if defined(TULIP_BUS_DMA)
diff -urN ../sys/pci/if_en_pci.c ./pci/if_en_pci.c
--- ../sys/pci/if_en_pci.c	Sun Aug 22 07:10:49 1999
+++ ./pci/if_en_pci.c	Tue Oct  2 22:06:22 2001
@@ -45,19 +45,17 @@
  * thanks to Matt Thomas for figuring out FreeBSD vs NetBSD vs etc.. diffs.
  */
 
-#include "en.h"
-
 #include <sys/param.h>
 #include <sys/kernel.h>
 #include <sys/systm.h>
-#if defined(__FreeBSD__)
-#include <sys/eventhandler.h>
-#endif
 #include <sys/malloc.h>
 #include <sys/socket.h>
 
+#include <sys/bus.h>
+#include <machine/bus.h>
+#include <sys/rman.h>
+#include <machine/resource.h>
 #include <machine/clock.h>		/* for DELAY */
-
 #include <net/if.h>
 
 #include <pci/pcivar.h>
@@ -71,9 +69,10 @@
  * prototypes
  */
 
-static	void en_pci_attach __P((pcici_t, int));
-static	const char *en_pci_probe __P((pcici_t, pcidi_t));
-static void en_pci_shutdown __P((void *, int));
+static	int en_pci_probe __P((device_t));
+static	int en_pci_attach __P((device_t));
+static	int en_pci_detach __P((device_t));
+static	int en_pci_shutdown __P((device_t));
 
 /*
  * local structures
@@ -83,43 +82,20 @@
   /* bus independent stuff */
   struct en_softc esc;		/* includes "device" structure */
 
-  /* PCI bus glue */
-  void *sc_ih;			/* interrupt handle */
-  pci_chipset_tag_t en_pc;	/* for PCI calls */
-  pcici_t en_confid;		/* config id */
+  /* freebsd newbus glue */
+  struct resource *res;		/* resource descriptor for registers */
+  struct resource *irq;		/* resource descriptor for interrupt */
+  void *ih;			/* interrupt handle */
 };
 
 #if !defined(MIDWAY_ENIONLY)
-static  void eni_get_macaddr __P((struct en_pci_softc *));
+static  void eni_get_macaddr __P((device_t, struct en_pci_softc *));
 #endif
 #if !defined(MIDWAY_ADPONLY)
 static  void adp_get_macaddr __P((struct en_pci_softc *));
 #endif
 
 /*
- * pointers to softcs (we alloc)
- */
-
-static struct en_pci_softc *enpcis[NEN] = {0};
-extern struct cfdriver en_cd;
-
-/*
- * autoconfig structures
- */
-
-static u_long en_pci_count;
-
-static struct pci_device endevice = {
-	"en",
-	en_pci_probe,
-	en_pci_attach,
-	&en_pci_count,
-	NULL,
-};  
-
-COMPAT_PCI_DRIVER (en, endevice);
-
-/*
  * local defines (PCI specific stuff)
  */
 
@@ -194,94 +170,104 @@
  * autoconfig stuff
  */
 
-static const char *en_pci_probe(config_id, device_id)
-
-pcici_t config_id;
-pcidi_t device_id;
-
+static int
+en_pci_probe(device_t dev)
 {
+  switch (pci_get_vendor(dev)) {
 #if !defined(MIDWAY_ADPONLY)
-  if (PCI_VENDOR(device_id) == PCI_VENDOR_EFFICIENTNETS && 
-      (PCI_CHIPID(device_id) == PCI_PRODUCT_EFFICIENTNETS_ENI155PF ||
-       PCI_CHIPID(device_id) == PCI_PRODUCT_EFFICIENTNETS_ENI155PA))
-    return "Efficient Networks ENI-155p";
+  case PCI_VENDOR_EFFICIENTNETS:
+    switch (pci_get_device(dev)) {
+    case PCI_PRODUCT_EFFICIENTNETS_ENI155PF:
+    case PCI_PRODUCT_EFFICIENTNETS_ENI155PA:
+      device_set_desc(dev, "Efficient Networks ENI-155p");
+      return 0;
+    }
+    break;
 #endif
-
 #if !defined(MIDWAY_ENIONLY)
-  if (PCI_VENDOR(device_id) == PCI_VENDOR_ADP && 
-      (PCI_CHIPID(device_id) == PCI_PRODUCT_ADP_AIC5900 ||
-       PCI_CHIPID(device_id) == PCI_PRODUCT_ADP_AIC5905))
-    return "Adaptec 155 ATM";
+  case PCI_VENDOR_ADP:
+    switch (pci_get_device(dev)) {
+    case PCI_PRODUCT_ADP_AIC5900:
+    case PCI_PRODUCT_ADP_AIC5905:
+      device_set_desc(dev, "Adaptec 155 ATM");
+      return 0;
+    }
+    break;
 #endif
-
-  return 0;
+  }
+  return ENXIO;
 }
 
-static void en_pci_attach(config_id, unit)
-
-pcici_t config_id;
-int unit;
-
+static int
+en_pci_attach(device_t dev)
 {
   struct en_softc *sc;
   struct en_pci_softc *scp;
-  pcidi_t device_id;
-  int retval;
-  vm_offset_t pa;
-
-  if (unit >= NEN) {
-    printf("en%d: not configured; kernel is built for only %d device%s.\n",
-	unit, NEN, NEN == 1 ? "" : "s");
-    return;
-  }
+  u_long val;
+  int rid, s, unit, error = 0;
 
-  scp = (struct en_pci_softc *) malloc(sizeof(*scp), M_DEVBUF, M_NOWAIT);
-  if (scp == NULL)
-    return;
+  sc = device_get_softc(dev);
+  scp = (struct en_pci_softc *)sc;
   bzero(scp, sizeof(*scp));		/* zero */
-  sc = &scp->esc;
 
-  retval = pci_map_mem(config_id, PCI_CBMA, (vm_offset_t *) &sc->en_base, &pa);
+  s = splimp();
 
-  if (!retval) {
-    free((caddr_t) scp, M_DEVBUF);
-    return;
-  }
-  enpcis[unit] = scp;			/* lock it in */
-  en_cd.cd_devs[unit] = sc;		/* fake a cfdriver structure */
-  en_cd.cd_ndevs = NEN;
-  snprintf(sc->sc_dev.dv_xname, sizeof(sc->sc_dev.dv_xname), "en%d", unit);
-  sc->enif.if_unit = unit;
-  sc->enif.if_name = "en";
-  scp->en_confid = config_id;
+  /*
+   * Enable bus mastering.
+   */
+  val = pci_read_config(dev, PCIR_COMMAND, 2);
+  val |= (PCIM_CMD_MEMEN|PCIM_CMD_BUSMASTEREN);
+  pci_write_config(dev, PCIR_COMMAND, val, 2);
 
   /*
-   * figure out if we are an adaptec card or not.
-   * XXX: why do we have to re-read PC_ID_REG when en_pci_probe already
-   * had that info?
+   * Map control/status registers.
    */
+  rid = PCI_CBMA;
+  scp->res = bus_alloc_resource(dev, SYS_RES_MEMORY, &rid,
+				0, ~0, 1, RF_ACTIVE);
+  if (!scp->res) {
+    device_printf(dev, "could not map memory\n");
+    error = ENXIO;
+    goto fail;
+  }
 
-  device_id = pci_conf_read(config_id, PCI_ID_REG);
-  sc->is_adaptec = (PCI_VENDOR(device_id) == PCI_VENDOR_ADP) ? 1 : 0;
+  sc->en_memt = rman_get_bustag(scp->res);
+  sc->en_base = rman_get_bushandle(scp->res);
   
   /*
-   * Add shutdown hook so that DMA is disabled prior to reboot. Not
-   * doing so could allow DMA to corrupt kernel memory during the
-   * reboot before the driver initializes.
+   * Allocate our interrupt.
    */
-  EVENTHANDLER_REGISTER(shutdown_post_sync, en_pci_shutdown, scp,
-			SHUTDOWN_PRI_DEFAULT);
+  rid = 0;
+  scp->irq = bus_alloc_resource(dev, SYS_RES_IRQ, &rid, 0, ~0, 1,
+				RF_SHAREABLE | RF_ACTIVE);
+  if (scp->irq == NULL) {
+    device_printf(dev, "could not map interrupt\n");
+    bus_release_resource(dev, SYS_RES_MEMORY, PCI_CBMA, scp->res);
+    error = ENXIO;
+    goto fail;
+  }
 
-  if (!pci_map_int(config_id, en_intr, (void *) sc, &net_imask)) {
-    printf("%s: couldn't establish interrupt\n", sc->sc_dev.dv_xname);
-    return;
+  error = bus_setup_intr(dev, scp->irq, INTR_TYPE_NET,
+			 en_intr, sc, &scp->ih);
+  if (error) {
+    device_printf(dev, "could not setup irq\n");
+    bus_release_resource(dev, SYS_RES_IRQ, 0, scp->irq);
+    bus_release_resource(dev, SYS_RES_MEMORY, PCI_CBMA, scp->res);
+    goto fail;
   }
-  sc->ipl = 1; /* XXX */
+  sc->ipl = 1; /* XXX (required to enable interrupt on midway) */
+
+  unit = device_get_unit(dev);
+  snprintf(sc->sc_dev.dv_xname, sizeof(sc->sc_dev.dv_xname), "en%d", unit);
+  sc->enif.if_unit = unit;
+  sc->enif.if_name = "en";
 
+  /* figure out if we are an adaptec card or not */
+  sc->is_adaptec = (pci_get_vendor(dev) == PCI_VENDOR_ADP) ? 1 : 0;
+  
   /*
    * set up pci bridge
    */
-
 #if !defined(MIDWAY_ENIONLY)
   if (sc->is_adaptec) {
     adp_get_macaddr(scp);
@@ -292,9 +278,9 @@
 
 #if !defined(MIDWAY_ADPONLY)
   if (!sc->is_adaptec) {
-    eni_get_macaddr(scp);
+    eni_get_macaddr(dev, scp);
     sc->en_busreset = NULL;
-    pci_conf_write(config_id, EN_TONGA, (TONGA_SWAP_DMA|TONGA_SWAP_WORD));
+    pci_write_config(dev, EN_TONGA, (TONGA_SWAP_DMA|TONGA_SWAP_WORD), 4);
   }
 #endif
 
@@ -304,26 +290,64 @@
 
   en_attach(sc);
 
+  splx(s);
+
+  return 0;
+
+ fail:
+  splx(s);
+  return error;
+}
+
+static int
+en_pci_detach(device_t dev)
+{
+	struct en_softc *sc = device_get_softc(dev);
+	struct en_pci_softc *scp = (struct en_pci_softc *)sc;
+	int s;
+
+	s = splimp();
+
+	/*
+	 * Close down routes etc.
+	 */
+	if_detach(&sc->enif);
+
+	/*
+	 * Stop DMA and drop transmit queue.
+	 */
+	en_reset(sc);
+
+	/*
+	 * Deallocate resources.
+	 */
+	bus_teardown_intr(dev, scp->irq, scp->ih);
+	bus_release_resource(dev, SYS_RES_IRQ, 0, scp->irq);
+	bus_release_resource(dev, SYS_RES_MEMORY, PCI_CBMA, scp->res);
+
+#ifdef notyet
+	/*
+	 * Free all the driver internal resources
+	 */
+#endif
+
+	splx(s);
+
+	return 0;
 }
 
-static void
-en_pci_shutdown(
-	void *sc,
-	int howto)
+static int
+en_pci_shutdown(device_t dev)
 {
-    struct en_pci_softc *psc = (struct en_pci_softc *)sc;
+    struct en_pci_softc *psc = (struct en_pci_softc *)device_get_softc(dev);
     
     en_reset(&psc->esc);
-    DELAY(10);
+    DELAY(10);	/* is this necessary? -kjc */
+    return (0);
 }
 
 #if !defined(MIDWAY_ENIONLY)
 
-#if defined(sparc) || defined(__FreeBSD__)
-#define bus_space_read_1(t, h, o) \
-  		((void)t, (*(volatile u_int8_t *)((h) + (o))))
-#endif
-
 static void 
 adp_get_macaddr(scp)
      struct en_pci_softc *scp;
@@ -332,8 +356,8 @@
   int lcv;
 
   for (lcv = 0; lcv < sizeof(sc->macaddr); lcv++)
-    sc->macaddr[lcv] = bus_space_read_1(sc->en_memt, sc->en_base,
-					MID_ADPMACOFF + lcv);
+	  sc->macaddr[lcv] = bus_space_read_1(sc->en_memt, sc->en_base,
+					      MID_ADPMACOFF + lcv);
 }
 
 #endif /* MIDWAY_ENIONLY */
@@ -350,90 +374,109 @@
 #define EN_ESI         64
 
 static void 
-eni_get_macaddr(scp)
-     struct en_pci_softc *scp;
+eni_get_macaddr(device_t dev, struct en_pci_softc *scp)
 {
   struct en_softc * sc = (struct en_softc *)scp;
-  pcici_t id = scp->en_confid;
   int i, j, address, status;
   u_int32_t data, t_data;
   u_int8_t tmp;
   
-  t_data = pci_conf_read(id, EN_TONGA) & 0xffffff00;
+  t_data = pci_read_config(dev, EN_TONGA, 4) & 0xffffff00;
 
   data =  EN_PROM_MAGIC | EN_PROM_DATA | EN_PROM_CLK;
-  pci_conf_write(id, EN_TONGA, data);
+  pci_write_config(dev, EN_TONGA, data, 4);
 
   for (i = 0; i < sizeof(sc->macaddr); i ++){
     /* start operation */
     data |= EN_PROM_DATA ;
-    pci_conf_write(id, EN_TONGA, data);
+    pci_write_config(dev, EN_TONGA, data, 4);
     data |= EN_PROM_CLK ;
-    pci_conf_write(id, EN_TONGA, data);
+    pci_write_config(dev, EN_TONGA, data, 4);
     data &= ~EN_PROM_DATA ;
-    pci_conf_write(id, EN_TONGA, data);
+    pci_write_config(dev, EN_TONGA, data, 4);
     data &= ~EN_PROM_CLK ;
-    pci_conf_write(id, EN_TONGA, data);
+    pci_write_config(dev, EN_TONGA, data, 4);
     /* send address with serial line */
     address = ((i + EN_ESI) << 1) + 1;
     for ( j = 7 ; j >= 0 ; j --){
       data = (address >> j) & 1 ? data | EN_PROM_DATA :
       data & ~EN_PROM_DATA;
-      pci_conf_write(id, EN_TONGA, data);
+      pci_write_config(dev, EN_TONGA, data, 4);
       data |= EN_PROM_CLK ;
-      pci_conf_write(id, EN_TONGA, data);
+      pci_write_config(dev, EN_TONGA, data, 4);
       data &= ~EN_PROM_CLK ;
-      pci_conf_write(id, EN_TONGA, data);
+      pci_write_config(dev, EN_TONGA, data, 4);
     }
     /* get ack */
     data |= EN_PROM_DATA ;
-    pci_conf_write(id, EN_TONGA, data);
+    pci_write_config(dev, EN_TONGA, data, 4);
     data |= EN_PROM_CLK ;
-    pci_conf_write(id, EN_TONGA, data);
-    data = pci_conf_read(id, EN_TONGA);
+    pci_write_config(dev, EN_TONGA, data, 4);
+    data = pci_read_config(dev, EN_TONGA, 4);
     status = data & EN_PROM_DATA;
     data &= ~EN_PROM_CLK ;
-    pci_conf_write(id, EN_TONGA, data);
+    pci_write_config(dev, EN_TONGA, data, 4);
     data |= EN_PROM_DATA ;
-    pci_conf_write(id, EN_TONGA, data);
+    pci_write_config(dev, EN_TONGA, data, 4);
 
     tmp = 0;
 
     for ( j = 7 ; j >= 0 ; j --){
       tmp <<= 1;
       data |= EN_PROM_DATA ;
-      pci_conf_write(id, EN_TONGA, data);
+      pci_write_config(dev, EN_TONGA, data, 4);
       data |= EN_PROM_CLK ;
-      pci_conf_write(id, EN_TONGA, data);
-      data = pci_conf_read(id, EN_TONGA);
+      pci_write_config(dev, EN_TONGA, data, 4);
+      data = pci_read_config(dev, EN_TONGA, 4);
       if(data & EN_PROM_DATA) tmp |= 1;
       data &= ~EN_PROM_CLK ;
-      pci_conf_write(id, EN_TONGA, data);
+      pci_write_config(dev, EN_TONGA, data, 4);
       data |= EN_PROM_DATA ;
-      pci_conf_write(id, EN_TONGA, data);
+      pci_write_config(dev, EN_TONGA, data, 4);
     }
     /* get ack */
     data |= EN_PROM_DATA ;
-    pci_conf_write(id, EN_TONGA, data);
+    pci_write_config(dev, EN_TONGA, data, 4);
     data |= EN_PROM_CLK ;
-    pci_conf_write(id, EN_TONGA, data);
-    data = pci_conf_read(id, EN_TONGA);
+    pci_write_config(dev, EN_TONGA, data, 4);
+    data = pci_read_config(dev, EN_TONGA, 4);
     status = data & EN_PROM_DATA;
     data &= ~EN_PROM_CLK ;
-    pci_conf_write(id, EN_TONGA, data);
+    pci_write_config(dev, EN_TONGA, data, 4);
     data |= EN_PROM_DATA ;
-    pci_conf_write(id, EN_TONGA, data);
+    pci_write_config(dev, EN_TONGA, data, 4);
 
     sc->macaddr[i] = tmp;
   }
   /* stop operation */
   data &=  ~EN_PROM_DATA;
-  pci_conf_write(id, EN_TONGA, data);
+  pci_write_config(dev, EN_TONGA, data, 4);
   data |=  EN_PROM_CLK;
-  pci_conf_write(id, EN_TONGA, data);
+  pci_write_config(dev, EN_TONGA, data, 4);
   data |=  EN_PROM_DATA;
-  pci_conf_write(id, EN_TONGA, data);
-  pci_conf_write(id, EN_TONGA, t_data);
+  pci_write_config(dev, EN_TONGA, data, 4);
+  pci_write_config(dev, EN_TONGA, t_data, 4);
 }
 
 #endif /* !MIDWAY_ADPONLY */
+
+static device_method_t en_methods[] = {
+	/* Device interface */
+	DEVMETHOD(device_probe,		en_pci_probe),
+	DEVMETHOD(device_attach,	en_pci_attach),
+	DEVMETHOD(device_detach,	en_pci_detach),
+	DEVMETHOD(device_shutdown,	en_pci_shutdown),
+
+	{ 0, 0 }
+};
+
+static driver_t en_driver = {
+	"en",
+	en_methods,
+	sizeof(struct en_pci_softc),
+};
+
+static devclass_t en_devclass;
+
+DRIVER_MODULE(if_en, pci, en_driver, en_devclass, 0, 0);
+
diff -urN ../sys/pci/if_fxp.c ./pci/if_fxp.c
--- ../sys/pci/if_fxp.c	Wed Oct 25 06:47:36 2000
+++ ./pci/if_fxp.c	Tue Oct  2 22:06:22 2001
@@ -421,6 +421,7 @@
 	ifp->if_ioctl = fxp_ioctl;
 	ifp->if_start = fxp_start;
 	ifp->if_watchdog = fxp_watchdog;
+	IFQ_SET_READY(&ifp->if_snd);
 
 	/*
 	 * Attach the interface.
@@ -430,7 +431,7 @@
 	 * Let the system queue as many packets as we have available
 	 * TX descriptors.
 	 */
-	ifp->if_snd.ifq_maxlen = FXP_NTXCB - 1;
+	IFQ_SET_MAXLEN(&ifp->if_snd, FXP_NTXCB - 1);
 	ether_ifattach(ifp, enaddr);
 	bpfattach(&sc->sc_ethercom.ec_if.if_bpf, ifp, DLT_EN10MB,
 	    sizeof(struct ether_header));
@@ -614,6 +615,7 @@
 	ifp->if_ioctl = fxp_ioctl;
 	ifp->if_start = fxp_start;
 	ifp->if_watchdog = fxp_watchdog;
+	IFQ_SET_READY(&ifp->if_snd);
 
 	/*
 	 * Attach the interface.
@@ -623,7 +625,7 @@
 	 * Let the system queue as many packets as we have available
 	 * TX descriptors.
 	 */
-	ifp->if_snd.ifq_maxlen = FXP_NTXCB - 1;
+	IFQ_SET_MAXLEN(&ifp->if_snd, FXP_NTXCB - 1);
 
 	splx(s);
 	return 0;
@@ -1068,14 +1070,16 @@
 	 * NOTE: One TxCB is reserved to guarantee that fxp_mc_setup() can add
 	 *       a NOP command when needed.
 	 */
-	while (ifp->if_snd.ifq_head != NULL && sc->tx_queued < FXP_NTXCB - 1) {
+	while (!IFQ_IS_EMPTY(&ifp->if_snd) && sc->tx_queued < FXP_NTXCB - 1) {
 		struct mbuf *m, *mb_head;
 		int segment;
 
 		/*
 		 * Grab a packet to transmit.
 		 */
-		IF_DEQUEUE(&ifp->if_snd, mb_head);
+		IFQ_DEQUEUE(&ifp->if_snd, mb_head);
+		if (mb_head == NULL)
+			break;
 
 		/*
 		 * Get pointer to next available tx desc.
@@ -1183,6 +1187,11 @@
 	 * going again if suspended.
 	 */
 	if (txp != NULL) {
+#ifdef ALTQ
+		/* if tb regulator is used, we need tx complete interrupt */
+		if (TBR_IS_ENABLED(&ifp->if_snd))
+			txp->cb_command |= FXP_CB_COMMAND_I;
+#endif
 		fxp_scb_wait(sc);
 		CSR_WRITE_1(sc, FXP_CSR_SCB_COMMAND, FXP_SCB_COMMAND_CU_RESUME);
 	}
@@ -1239,7 +1248,7 @@
 			/*
 			 * Try to start more packets transmitting.
 			 */
-			if (ifp->if_snd.ifq_head != NULL)
+			if (!IFQ_IS_EMPTY(&ifp->if_snd))
 				fxp_start(ifp);
 		}
 		/*
